﻿-- Best Seller Event Handler

function bsRegisterEvent(event)
    if( event ~= nil ) then
        BSFrame:RegisterEvent(event);
    end
end

lastitembuyback=0;

function bsOnEvent(self, event, ...)
    local arg1, arg2 = ...;
    narg=bsNargify(arg1);
    if (db) then
        if (db.DebugShowAllEvents) then
            bsDPrint(" BEST SELLER EVENT ["..event.."]");
        end
    end

    if (event == "VARIABLES_LOADED") then ------------------------------------[Save Variables]

        bsDPrint("LOADED");

	    if( not BestSellerDatabase ) then
            BestSellerDatabase={};
	    end
	    if( not BestSellerDatabase[GetRealmName()] ) then
            BestSellerDatabase[GetRealmName()]={};
        end
	    if( not BestSellerDatabase[GetRealmName()][UnitName("player")] ) then
            BestSellerDatabase[GetRealmName()][UnitName("player")]={};
        end

    	db = BestSellerDatabase[GetRealmName()][UnitName("player")];

    	db.WTF="hi";

	    if(db) then

	        if(db.BestSellerDebug==nil) then db.BestSellerDebug = 0; end

            db["Version"]	= BestSeller_Version;
            db["Name"]		= UnitName("player");
            db["Server"]	= GetRealmName();
            db["Locale"]	= GetLocale();
            db["Race"],
            db["RaceEn"]    =UnitRace("player")
            db["Class"],
            db["ClassEn"]   =UnitClass("player");
            db["FactionEn"],
            db["Faction"]   =UnitFactionGroup("player");

            if(db.Enabled==nil)                 then db.Enabled = 1; end
            if(db.AutoRepair==nil)              then db.AutoRepair = 0; end
            if(db.GuildFundedRepair==nil)       then db.GuildFundedRepair = 0; end

            if(db.AutoSell==nil)                then db.AutoSell = {}; end
            if(db.AutoSell["Active"]==nil)      then db.AutoSell["Active"]=0; end
            if(db.AutoSell["Safe"]==nil)        then db.AutoSell["Safe"]=0; end
            if(db.AutoSell["GreyOnly"]==nil)    then db.AutoSell["GreyOnly"]=0; end
            if(db.AutoSell["Remember"]==nil)    then db.AutoSell["Remember"]=0; end
            if(db.AutoSell["Soulbound"]==nil)   then db.AutoSell["Soulbound"] = 0; end
            if(db.AutoSell["LowFoods"]==nil)    then db.AutoSell["LowFoods"] = 0; end
            if(db.AutoSell["Items"]==nil)       then db.AutoSell["Items"] = {}; end
            if(db.AutoSell["Exclude"]==nil)     then db.AutoSell["Exclude"] = {}; end


            --if(db.AutoBuy==nil)                 then
            db.AutoBuy = {};
            --end

            if(db.AutoBuy["Active"]==nil)       then db.AutoBuy["Active"]=0; end

	    end

        rpxpmsg=1;
        rpxpsession=0;

        bsPrint(RFCC.."BestSeller ["..bsVersion.."] by Smashed (Bladefist - Alliance) loaded. For help type "..YFCC.."/bs help");

        BSAMFramePanel1CheckAutoSell:SetChecked(db.AutoSell["Active"]);
        BSAMFramePanel1CheckSafe:SetChecked(db.AutoSell["Safe"]);

        BSAMFramePanel1CheckGreyOnly:SetChecked(db.AutoSell["GreyOnly"]);
        BSAMFramePanel1CheckMem:SetChecked(db.AutoSell["Remember"]);

        BSAMFramePanel1CheckLowFoods:SetChecked(db.AutoSell["LowFoods"]);

        BSAMFramePanel1CheckSoulbound:SetChecked(db.AutoSell["Soulbound"]);

        if(db.AutoSell["SoulboundQuality"]==nil) then
            db.AutoSell["SoulboundQuality"]=0;
        end

        if(db.AutoSell["SoulboundQuality"]~=nil) then
            UIDropDownMenu_SetSelectedValue(BSAMFramePanel1ComboBox1,db.AutoSell["SoulboundQuality"]);
            BSAMFramePanel1ComboBox1Text:SetText(ITEM_QUALITY[db.AutoSell["SoulboundQuality"]]);
        end

        if(db.AutoSell["SoulboundLow"]==nil) then db.AutoSell["SoulboundLow"]=2; end
        BSAMFramePanel1SoulboundLow:SetText(db.AutoSell["SoulboundLow"]);
        if(db.AutoSell["SoulboundHigh"]==nil) then db.AutoSell["SoulboundHigh"]=74; end
        BSAMFramePanel1SoulboundHigh:SetText(db.AutoSell["SoulboundHigh"]);


        BSAMFramePanel1CheckSellBOE:SetChecked(db.AutoSell["BOE"]);

        if(db.AutoSell["BOEQuality"]==nil) then
            db.AutoSell["BOEQuality"]=0;
        end

        if(db.AutoSell["BOEQuality"]~=nil) then
            UIDropDownMenu_SetSelectedValue(BSAMFramePanel1ComboBoxBOEQuality,db.AutoSell["BOEQuality"]);
            BSAMFramePanel1ComboBoxBOEQualityText:SetText(ITEM_QUALITY[db.AutoSell["BOEQuality"]]);
        end

        if(db.AutoSell["BOELow"]==nil) then db.AutoSell["BOELow"]=2; end
        BSAMFramePanel1BOELow:SetText(db.AutoSell["BOELow"]);
        if(db.AutoSell["BOEHigh"]==nil) then db.AutoSell["BOEHigh"]=74; end
        BSAMFramePanel1BOEHigh:SetText(db.AutoSell["BOEHigh"]);

        BSAMFramePanel2CheckAutoBuy:SetChecked(db.AutoBuy["Active"]);

        BSAMFramePanel3CheckAutoRepair:SetChecked(db.AutoRepair);
        BSAMFramePanel3CheckGuildFundedRepair:SetChecked(db.GuildFundedRepair);

		BSMMButton:SetPoint("CENTER", "UIParent", "BOTTOMLEFT", (db.MMX or 512), (db.MMY or 384));

        db.bsChatFrame=DEFAULT_CHAT_FRAME;

        bsASLCreateButtons();
        bsEXLCreateButtons();

        BSAMFramePanel1CheckSellBOE:Disable();
        BSAMFramePanel1ComboBoxBOEQuality:Disable();
        --BSAMFramePanel1LabelBOEQuality:Disable();
        --BSAMFramePanel1LabelMiniLevelBOE:Disable();
        --BSAMFramePanel1BOELow:Disable();
        --BSAMFramePanel1LabelMaxiLevelBOE:Disable();
        --BSAMFramePanel1BOEHigh:Disable();

        BSAMFramePanel1CheckLevel80Mode:Disable();
        BSAMFramePanel1CheckLevel85SellMode:Disable();
        BSAMFramePanel1CheckQuestHighest:Disable();

    end

    if (event == "UPDATE_CHAT_WINDOWS") then
        bsSetDebugWindow();
    end

    if (event == "PLAYER_LOGOUT") then
		db.MMX, db.MMY = BSMMButton:GetCenter();
	end
    if (event == "UNIT_INVENTORY_CHANGED") then
        -- bsDPrint("UNIT_INVENTORY_CHANGED"..narg[1]);
    end

    if (event == "MERCHANT_SHOW") then

        bMerchantOpen=1;

        if(db.AutoSell["Active"]==1) then
            bsAutoSell();
        end

        if(CanMerchantRepair()) then
            if(db.AutoRepair==1) then
                RepairAllItems(db.GuildFundedRepair);
                if(db.GuildFundedRepair==1) then
                    bsInform("Repaired items from guild funds");
                else
                    bsInform("Repaired items from personal funds");
                end
            end
		end

        if(db.AutoBuy["Active"]==1) then
            bsAutoBuy();
        end

    end

    if (event == "MERCHANT_CLOSED") then
        bMerchantOpen=0;
    end

    if (event == "MERCHANT_UPDATE") then

        if(bAutoSellActive==0) then
            local numitms=GetNumBuybackItems();
            bsDPrint("Num Buyback Items:"..numitms);
            --GetBuybackItemLink(index)
            local sitem=GetBuybackItemLink(GetNumBuybackItems());

            --local curframe=GetMouseFocus():GetName();
            local curframe=" ";

            selling=1;
            for i=0,12 do
                whichbut="MerchantItem"..i.."ItemButton";
                if(curframe==whichbut) then
                    selling=0;
                end
            end
            if (curframe=="MerchantBuyBackItemItemButton") then
                selling=0;
            end
            if(selling==0) then
                bsAddExcludeItem(sitem);
            else
                if(db.AutoSell["Remember"]==1) then
                    bsAddSellItem(sitem);
                end
            end
        end
    end

end

